Loading...
Searching...
No Matches
Opm::BlackOilSolventModule< TypeTag, enableSolventV > Class Template Reference

Contains the high level supplements required to extend the black oil model by solvents. More...

`#include <blackoilsolventmodules.hh>`

## Static Public Member Functions

static void | setParams (BlackOilSolventParams< Scalar > &&params)
| Set parameters.
static void | setSolventPvt (const SolventPvt &value)
| Specify the solvent PVT of a all PVT regions.
static void | setIsMiscible (const bool isMiscible)
static void | registerParameters ()
| Register all run-time parameters for the black-oil solvent module.
static void | registerOutputModules (Model &model, Simulator &simulator)
| Register all solvent specific VTK and ECL output modules.
static bool | primaryVarApplies (unsigned pvIdx)
static std::string | primaryVarName (unsigned pvIdx)
static Scalar | primaryVarWeight (unsigned pvIdx)
static bool | eqApplies (unsigned eqIdx)
static std::string | eqName (unsigned eqIdx)
static Scalar | eqWeight (unsigned eqIdx)
template<class LhsEval>
static void | addStorage (Dune::FieldVector< LhsEval, numEq > &storage, const IntensiveQuantities &intQuants)
static void | computeFlux (RateVector &flux, const ElementContext &elemCtx, unsigned scvfIdx, unsigned timeIdx)
static void | assignPrimaryVars (PrimaryVariables &priVars, Scalar solventSaturation, Scalar solventRsw)
| Assign the solvent specific primary variables to a PrimaryVariables object.
static void | updatePrimaryVars (PrimaryVariables &newPv, const PrimaryVariables &oldPv, const EqVector &delta)
| Do a Newton-Raphson update the primary variables of the solvents.
static Scalar | computeUpdateError (const PrimaryVariables &, const EqVector &)
| Return how much a Newton-Raphson update is considered an error.
static Scalar | computeResidualError (const EqVector &resid)
| Return how much a residual is considered an error.
template<class DofEntity>
static void | serializeEntity (const Model &model, std::ostream &outstream, const DofEntity &dof)
template<class DofEntity>
static void | deserializeEntity (Model &model, std::istream &instream, const DofEntity &dof)
static const SolventPvt & | solventPvt ()
static const Co2GasPvt & | co2GasPvt ()
static const H2GasPvt & | h2GasPvt ()
static const BrineCo2Pvt & | brineCo2Pvt ()
static const BrineH2Pvt & | brineH2Pvt ()
template<class ElemContext>
static const TabulatedFunction & | ssfnKrg (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | ssfnKrs (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | sof2Krn (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | misc (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | pmisc (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | msfnKrsg (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | msfnKro (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | sorwmis (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | sgcwmis (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static const TabulatedFunction & | tlPMixTable (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static Scalar | tlMixParamViscosity (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
template<class ElemContext>
static Scalar | tlMixParamDensity (const ElemContext &elemCtx, unsigned scvIdx, unsigned timeIdx)
static bool | isMiscible ()
template<class Value>
static Value | solubilityLimit (unsigned pvtIdx, const Value &temperature, const Value &pressure, const Value &saltConcentration)
static bool | isSolubleInWater ()
static bool | isCO2Sol ()
static bool | isH2Sol ()

## Detailed Description

template<class TypeTag, bool enableSolventV = getPropValue<TypeTag, Properties::EnableSolvent>()>
class Opm::BlackOilSolventModule< TypeTag, enableSolventV >

Contains the high level supplements required to extend the black oil model by solvents.

The documentation for this class was generated from the following file:

- opm/models/blackoil/blackoilsolventmodules.hh